// Commands.h : wb_[ t@C
//
/**/#if!defined(AFX_COMMANDS_H__3A01C425_8FF6_4391_AF43_9E55C91B5D3C__INCLUDED_)
	#define AFX_COMMANDS_H__3A01C425_8FF6_4391_AF43_9E55C91B5D3C__INCLUDED_

	/**/#include "sampleaddTypes.h"
	#include "codeformatni.h"
	#include "DragScrollNi.h"
	#include <afxtempl.h>
extern IApplication*m_pApplication;

class ATL_NO_VTABLE CFormatEvent:
	public IDispatchImpl<ICodeOrderEvents,&IID_ICodeOrderEvents,&LIBID_CODEFORMATNILib>,
	public CComObjectRoot
{
public:
	CFormatEvent(){}
	~CFormatEvent(){

	}

	BEGIN_COM_MAP(CFormatEvent)
		COM_INTERFACE_ENTRY(ICodeOrderEvents)
		COM_INTERFACE_ENTRY2(IDispatch,ICodeOrderEvents)
	END_COM_MAP()
public:
	// ICodeOrderEvents
	STDMETHOD(FormatProgress)(LONG line,LONG actWinhandle,ICodeOrder*pCodeOrder,CY*pVal);
	STDMETHOD(FormatedResult)(BSTR formatedCode,ICodeOrder*pCodeOrder,BSTR StopData);
	STDMETHOD(caretOwnerSession)(long SessionNumber,ICodeOrder*pCodeOrder,BSTR StopData);
};

class ATL_NO_VTABLE CDragScrollEvent:
	public IDispatchImpl<IDragScrollEvents,&IID_IDragScrollEvents,&LIBID_DRAGSCROLLNILib>,
	public CComObjectRoot
{
public:
	CDragScrollEvent(){}
	~CDragScrollEvent(){

	}


	BEGIN_COM_MAP(CDragScrollEvent)
		COM_INTERFACE_ENTRY(IDragScrollEvents)
		COM_INTERFACE_ENTRY2(IDispatch,IDragScrollEvents)
	END_COM_MAP()


public:
	// IDragScrollEvents
	STDMETHOD(get_RbuttonDownUp)(LONG mouseposition,LONG winhandle,BOOL RbuttonDown,IDragScroll*IDragScrollPtr,CY*pVal);
	STDMETHOD(RbuttonDownWithMbuttonDown)(long provisionalLine,long provisionalCol,long winhandle,long mode,IDragScroll*IDragScrollPtr);
	STDMETHOD(get_wmchar)(long wParam,long lParam,LONG winhandle,long CurWintype,IDragScroll*IDragScrollPtr,CY*pVal);
	STDMETHOD(get_InquireRevisionData)(LONG winhandle,long CurWintype,IDragScroll*IDragScrollPtr,CY*pVal);
};

struct STOREDPOS
{
	long line;
	long col;
	CString name;
};


class CCommands:
	public CComDualImpl<ICommands,&IID_ICommands,&LIBID_Sampleadd>,
	public CComObjectRoot,
	public CComCoClass<CCommands,&CLSID_Commands>
{
protected:

public:
	CCommands();
	~CCommands();

	void SetApplicationObject(IApplication*m_pApplication);
	IApplication*GetApplicationObject(){return m_pApplication;}
	void UnadviseFromEvents();

	BEGIN_COM_MAP(CCommands)
		COM_INTERFACE_ENTRY(IDispatch)
		COM_INTERFACE_ENTRY(ICommands)
	END_COM_MAP()
	DECLARE_NOT_AGGREGATABLE(CCommands)
protected:
	// ̃NX ev[g͈ȉɐ錾ꂽAvP[V Cxg nh
	// IuWFNgуfobK Cxg nh IuWFNg̊{NXƂ
	// gp܂B
	template<class IEvents,const IID*piidEvents,const GUID*plibid,
		class XEvents,const CLSID*pClsidEvents>
		class XEventHandler:
		public CComDualImpl<IEvents,piidEvents,plibid>,
		public CComObjectRoot,
		public CComCoClass<XEvents,pClsidEvents>
	{
	public:
		BEGIN_COM_MAP(XEvents)
			COM_INTERFACE_ENTRY(IDispatch)
			COM_INTERFACE_ENTRY_IID(*piidEvents,IEvents)
		END_COM_MAP()
		DECLARE_NOT_AGGREGATABLE(XEvents)
		void Connect(IUnknown*pUnk)
		{ VERIFY(SUCCEEDED(AtlAdvise(pUnk,this,*piidEvents,&m_dwAdvise)));}
		void Disconnect(IUnknown*pUnk)
		{ AtlUnadvise(pUnk,*piidEvents,m_dwAdvise);}


	protected:
		DWORD m_dwAdvise;
	};
	CComQIPtr<IDebugger,&IID_IDebugger>applipDebugger;
	CComQIPtr<IBreakpoints,&IID_IBreakpoints>ppappliBrkPnts;

	// ̃IuWFNg̓AvP[V IuWFNgɂđꂽCxg܂B
	class XApplicationEvents:public XEventHandler<IApplicationEvents, 
		&IID_IApplicationEvents,&LIBID_Sampleadd, 
		XApplicationEvents,&CLSID_ApplicationEvents>
	{
	public:
		// IApplicationEvents \bh
		STDMETHOD(BeforeBuildStart)(THIS);
		STDMETHOD(BuildFinish)(THIS_ long nNumErrors,long nNumWarnings);
		STDMETHOD(BeforeApplicationShutDown)(THIS);
		STDMETHOD(DocumentOpen)(THIS_ IDispatch*theDocument);
		STDMETHOD(BeforeDocumentClose)(THIS_ IDispatch*theDocument);
		STDMETHOD(DocumentSave)(THIS_ IDispatch*theDocument);
		STDMETHOD(NewDocument)(THIS_ IDispatch*theDocument);
		STDMETHOD(WindowActivate)(THIS_ IDispatch*theWindow);
		STDMETHOD(WindowDeactivate)(THIS_ IDispatch*theWindow);
		STDMETHOD(WorkspaceOpen)(THIS);
		STDMETHOD(WorkspaceClose)(THIS);
		STDMETHOD(NewWorkspace)(THIS);
	};
	typedef CComObject<XApplicationEvents>XApplicationEventsObj;
	XApplicationEventsObj*m_pApplicationEventsObj;

	// ̃IuWFNg̓AvP[V IuWFNgɂđꂽCxg܂B
	class XDebuggerEvents:public XEventHandler<IDebuggerEvents, 
		&IID_IDebuggerEvents,&LIBID_Sampleadd, 
		XDebuggerEvents,&CLSID_DebuggerEvents>
	{
	public:
		// IDebuggerEvents \bh
		STDMETHOD(BreakpointHit)(THIS_ IDispatch*pBreakpoint);
	};
	typedef CComObject<XDebuggerEvents>XDebuggerEventsObj;
	XDebuggerEventsObj*m_pDebuggerEventsObj;

public:
	STDMETHOD(backposition)();
	VOID storedpositionsFunc(CComBSTR&data);
	STDMETHOD(dragscroll)();
	HRESULT StopDispAndconnect(long Session,LONG curWin=0);
	STDMETHOD(general)();
	VOID Getbreakpoint(CComQIPtr<ITextDocument,&IID_ITextDocument>&pActiveDocument,
					   CComQIPtr<ITextSelection,&IID_ITextSelection>&pTextSelection,
					   ICodeOrder*pCodeorder,
					   CList<long,long>&nonamebookmark,
					   CComBSTR&text,long topline,long bottomline);
	LONG formatedCodePaste(CComQIPtr<ITextDocument,&IID_ITextDocument>&pActiveDocument,
						   CComQIPtr<ITextSelection,&IID_ITextSelection>&pTextSelection,
						   ICodeOrder*pCodeorder,
						   BSTR&FormatedText,long&Errorline,long&Errorcol,long&multiErrorcol,
						   long&newbottomline,long&newbottomcol,long&multinewbottomcol,
						   long&regiontopline,long&regionbottomline,long SessionNumber
						   );
	STDMETHOD(newSelectbracket)();
	STDMETHOD(InsertCodeFormat)();
	STDMETHOD(LicenceCodeFormat)();
	STDMETHOD(bracket)(THIS);
	STDMETHOD(CodeFormat)(THIS);


	// ICommands \bh
	CComBSTR charInsertText;				  //}Cӂ̕w߂܂B
	CComQIPtr<IDragScroll,&IID_IDragScroll>pDragScroll;
	CY revisionData;
	HWND actwinh;
	CComQIPtr<ITextDocument,&IID_ITextDocument>reservepActiveDocument;
	CComBSTR reserveName;
	CComBSTR reservetype;
	long reserveline;
	long reservecol;
	CComBSTR OrgCopytext;
	long copypasteline,copypastecol;
	CList<STOREDPOS,STOREDPOS>storedpositions;//
	POSITION goposition;
};

typedef CComObject<CCommands>CCommandsObj;


//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_COMMANDS_H__3A01C425_8FF6_4391_AF43_9E55C91B5D3C__INCLUDED)
